import * as ss from "superstruct";
export declare const ContentModelStringKind: ss.Struct<"string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url", {
    string: "string";
    brand_id: "brand_id";
    category_id: "category_id";
    color: "color";
    content_block_id: "content_block_id";
    dropdown: "dropdown";
    file_id: "file_id";
    image_file_id: "image_file_id";
    product_id: "product_id";
    radio: "radio";
    textarea: "textarea";
    variant_id: "variant_id";
    web_url: "web_url";
}>;
export declare const ContentModelNumberKind: ss.Struct<"number" | "percentage" | "rating", {
    number: "number";
    percentage: "percentage";
    rating: "rating";
}>;
export declare const ContentModelBooleanKind: ss.Struct<"checkbox" | "toggle", {
    checkbox: "checkbox";
    toggle: "toggle";
}>;
export declare const ContentModelDatetimeKind: ss.Struct<"date" | "datetime", {
    date: "date";
    datetime: "datetime";
}>;
export declare const ContentModelEnumValue: ss.Struct<{
    label: string;
    value: string;
}, {
    label: ss.Struct<string, null>;
    value: ss.Struct<string, null>;
}>;
export declare const ContentModelStringValidation: ss.Struct<{
    minLength?: number | undefined;
    minLengthError?: string | undefined;
    maxLength?: number | undefined;
    maxLengthError?: string | undefined;
    pattern?: string | undefined;
    patternError?: string | undefined;
    enum?: {
        label: string;
        value: string;
    }[] | undefined;
    defaultValue?: string | undefined;
}, {
    minLength: ss.Struct<number | undefined, null>;
    minLengthError: ss.Struct<string | undefined, null>;
    maxLength: ss.Struct<number | undefined, null>;
    maxLengthError: ss.Struct<string | undefined, null>;
    pattern: ss.Struct<string | undefined, null>;
    patternError: ss.Struct<string | undefined, null>;
    enum: ss.Struct<{
        label: string;
        value: string;
    }[] | undefined, ss.Struct<{
        label: string;
        value: string;
    }, {
        label: ss.Struct<string, null>;
        value: ss.Struct<string, null>;
    }>>;
    defaultValue: ss.Struct<string | undefined, null>;
}>;
export declare const ContentModelNumberValidation: ss.Struct<{
    min?: number | undefined;
    minError?: string | undefined;
    max?: number | undefined;
    maxError?: string | undefined;
    integer?: boolean | undefined;
}, {
    min: ss.Struct<number | undefined, null>;
    minError: ss.Struct<string | undefined, null>;
    max: ss.Struct<number | undefined, null>;
    maxError: ss.Struct<string | undefined, null>;
    integer: ss.Struct<boolean | undefined, null>;
}>;
export declare const ContentModelTypeFieldProps: ss.Struct<{
    name: string;
    label?: string | undefined;
}, {
    name: ss.Struct<string, null>;
    label: ss.Struct<string | undefined, null>;
}>;
export declare const ContentModelType_String: ss.Struct<{
    type: "string";
    kind: "string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url";
    validation?: {
        minLength?: number | undefined;
        minLengthError?: string | undefined;
        maxLength?: number | undefined;
        maxLengthError?: string | undefined;
        pattern?: string | undefined;
        patternError?: string | undefined;
        enum?: {
            label: string;
            value: string;
        }[] | undefined;
        defaultValue?: string | undefined;
    } | undefined;
    help?: string | undefined;
}, {
    type: ss.Struct<"string", "string">;
    kind: ss.Struct<"string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url", {
        string: "string";
        brand_id: "brand_id";
        category_id: "category_id";
        color: "color";
        content_block_id: "content_block_id";
        dropdown: "dropdown";
        file_id: "file_id";
        image_file_id: "image_file_id";
        product_id: "product_id";
        radio: "radio";
        textarea: "textarea";
        variant_id: "variant_id";
        web_url: "web_url";
    }>;
    validation: ss.Struct<{
        minLength?: number | undefined;
        minLengthError?: string | undefined;
        maxLength?: number | undefined;
        maxLengthError?: string | undefined;
        pattern?: string | undefined;
        patternError?: string | undefined;
        enum?: {
            label: string;
            value: string;
        }[] | undefined;
        defaultValue?: string | undefined;
    } | undefined, {
        minLength: ss.Struct<number | undefined, null>;
        minLengthError: ss.Struct<string | undefined, null>;
        maxLength: ss.Struct<number | undefined, null>;
        maxLengthError: ss.Struct<string | undefined, null>;
        pattern: ss.Struct<string | undefined, null>;
        patternError: ss.Struct<string | undefined, null>;
        enum: ss.Struct<{
            label: string;
            value: string;
        }[] | undefined, ss.Struct<{
            label: string;
            value: string;
        }, {
            label: ss.Struct<string, null>;
            value: ss.Struct<string, null>;
        }>>;
        defaultValue: ss.Struct<string | undefined, null>;
    }>;
    help: ss.Struct<string | undefined, null>;
}>;
export declare const ContentModelType_Datetime: ss.Struct<{
    type: "datetime";
    kind: "date" | "datetime";
    help?: string | undefined;
}, {
    type: ss.Struct<"datetime", "datetime">;
    kind: ss.Struct<"date" | "datetime", {
        date: "date";
        datetime: "datetime";
    }>;
    help: ss.Struct<string | undefined, null>;
}>;
export declare const ContentModelType_Boolean: ss.Struct<{
    type: "boolean";
    kind: "checkbox" | "toggle";
    help?: string | undefined;
}, {
    type: ss.Struct<"boolean", "boolean">;
    kind: ss.Struct<"checkbox" | "toggle", {
        checkbox: "checkbox";
        toggle: "toggle";
    }>;
    help: ss.Struct<string | undefined, null>;
}>;
export declare const ContentModelType_Number: ss.Struct<{
    type: "number";
    kind: "number" | "percentage" | "rating";
    validation?: {
        min?: number | undefined;
        minError?: string | undefined;
        max?: number | undefined;
        maxError?: string | undefined;
        integer?: boolean | undefined;
    } | undefined;
    help?: string | undefined;
}, {
    type: ss.Struct<"number", "number">;
    kind: ss.Struct<"number" | "percentage" | "rating", {
        number: "number";
        percentage: "percentage";
        rating: "rating";
    }>;
    validation: ss.Struct<{
        min?: number | undefined;
        minError?: string | undefined;
        max?: number | undefined;
        maxError?: string | undefined;
        integer?: boolean | undefined;
    } | undefined, {
        min: ss.Struct<number | undefined, null>;
        minError: ss.Struct<string | undefined, null>;
        max: ss.Struct<number | undefined, null>;
        maxError: ss.Struct<string | undefined, null>;
        integer: ss.Struct<boolean | undefined, null>;
    }>;
    help: ss.Struct<string | undefined, null>;
}>;
export declare const NonObjectContentModelType: ss.Struct<{
    type: "string";
    kind: "string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url";
    validation?: {
        minLength?: number | undefined;
        minLengthError?: string | undefined;
        maxLength?: number | undefined;
        maxLengthError?: string | undefined;
        pattern?: string | undefined;
        patternError?: string | undefined;
        enum?: {
            label: string;
            value: string;
        }[] | undefined;
        defaultValue?: string | undefined;
    } | undefined;
    help?: string | undefined;
} | {
    type: "datetime";
    kind: "date" | "datetime";
    help?: string | undefined;
} | {
    type: "boolean";
    kind: "checkbox" | "toggle";
    help?: string | undefined;
} | {
    type: "number";
    kind: "number" | "percentage" | "rating";
    validation?: {
        min?: number | undefined;
        minError?: string | undefined;
        max?: number | undefined;
        maxError?: string | undefined;
        integer?: boolean | undefined;
    } | undefined;
    help?: string | undefined;
}, null>;
export declare const ContentModelObjectField: ss.Struct<({
    type: "string";
    kind: "string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url";
    validation?: {
        minLength?: number | undefined;
        minLengthError?: string | undefined;
        maxLength?: number | undefined;
        maxLengthError?: string | undefined;
        pattern?: string | undefined;
        patternError?: string | undefined;
        enum?: {
            label: string;
            value: string;
        }[] | undefined;
        defaultValue?: string | undefined;
    } | undefined;
    help?: string | undefined;
} | {
    type: "datetime";
    kind: "date" | "datetime";
    help?: string | undefined;
} | {
    type: "boolean";
    kind: "checkbox" | "toggle";
    help?: string | undefined;
} | {
    type: "number";
    kind: "number" | "percentage" | "rating";
    validation?: {
        min?: number | undefined;
        minError?: string | undefined;
        max?: number | undefined;
        maxError?: string | undefined;
        integer?: boolean | undefined;
    } | undefined;
    help?: string | undefined;
}) & {
    name: string;
    label?: string | undefined;
}, null>;
export declare const ContentModelType_Object: ss.Struct<{
    type: "object";
    fields: (({
        type: "string";
        kind: "string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url";
        validation?: {
            minLength?: number | undefined;
            minLengthError?: string | undefined;
            maxLength?: number | undefined;
            maxLengthError?: string | undefined;
            pattern?: string | undefined;
            patternError?: string | undefined;
            enum?: {
                label: string;
                value: string;
            }[] | undefined;
            defaultValue?: string | undefined;
        } | undefined;
        help?: string | undefined;
    } | {
        type: "datetime";
        kind: "date" | "datetime";
        help?: string | undefined;
    } | {
        type: "boolean";
        kind: "checkbox" | "toggle";
        help?: string | undefined;
    } | {
        type: "number";
        kind: "number" | "percentage" | "rating";
        validation?: {
            min?: number | undefined;
            minError?: string | undefined;
            max?: number | undefined;
            maxError?: string | undefined;
            integer?: boolean | undefined;
        } | undefined;
        help?: string | undefined;
    }) & {
        name: string;
        label?: string | undefined;
    })[];
    help?: string | undefined;
}, {
    type: ss.Struct<"object", "object">;
    fields: ss.Struct<(({
        type: "string";
        kind: "string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url";
        validation?: {
            minLength?: number | undefined;
            minLengthError?: string | undefined;
            maxLength?: number | undefined;
            maxLengthError?: string | undefined;
            pattern?: string | undefined;
            patternError?: string | undefined;
            enum?: {
                label: string;
                value: string;
            }[] | undefined;
            defaultValue?: string | undefined;
        } | undefined;
        help?: string | undefined;
    } | {
        type: "datetime";
        kind: "date" | "datetime";
        help?: string | undefined;
    } | {
        type: "boolean";
        kind: "checkbox" | "toggle";
        help?: string | undefined;
    } | {
        type: "number";
        kind: "number" | "percentage" | "rating";
        validation?: {
            min?: number | undefined;
            minError?: string | undefined;
            max?: number | undefined;
            maxError?: string | undefined;
            integer?: boolean | undefined;
        } | undefined;
        help?: string | undefined;
    }) & {
        name: string;
        label?: string | undefined;
    })[], ss.Struct<({
        type: "string";
        kind: "string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url";
        validation?: {
            minLength?: number | undefined;
            minLengthError?: string | undefined;
            maxLength?: number | undefined;
            maxLengthError?: string | undefined;
            pattern?: string | undefined;
            patternError?: string | undefined;
            enum?: {
                label: string;
                value: string;
            }[] | undefined;
            defaultValue?: string | undefined;
        } | undefined;
        help?: string | undefined;
    } | {
        type: "datetime";
        kind: "date" | "datetime";
        help?: string | undefined;
    } | {
        type: "boolean";
        kind: "checkbox" | "toggle";
        help?: string | undefined;
    } | {
        type: "number";
        kind: "number" | "percentage" | "rating";
        validation?: {
            min?: number | undefined;
            minError?: string | undefined;
            max?: number | undefined;
            maxError?: string | undefined;
            integer?: boolean | undefined;
        } | undefined;
        help?: string | undefined;
    }) & {
        name: string;
        label?: string | undefined;
    }, null>>;
    help: ss.Struct<string | undefined, null>;
}>;
export declare const ContentModelType: ss.Struct<{
    type: "string";
    kind: "string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url";
    validation?: {
        minLength?: number | undefined;
        minLengthError?: string | undefined;
        maxLength?: number | undefined;
        maxLengthError?: string | undefined;
        pattern?: string | undefined;
        patternError?: string | undefined;
        enum?: {
            label: string;
            value: string;
        }[] | undefined;
        defaultValue?: string | undefined;
    } | undefined;
    help?: string | undefined;
} | {
    type: "datetime";
    kind: "date" | "datetime";
    help?: string | undefined;
} | {
    type: "boolean";
    kind: "checkbox" | "toggle";
    help?: string | undefined;
} | {
    type: "number";
    kind: "number" | "percentage" | "rating";
    validation?: {
        min?: number | undefined;
        minError?: string | undefined;
        max?: number | undefined;
        maxError?: string | undefined;
        integer?: boolean | undefined;
    } | undefined;
    help?: string | undefined;
} | {
    type: "object";
    fields: (({
        type: "string";
        kind: "string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url";
        validation?: {
            minLength?: number | undefined;
            minLengthError?: string | undefined;
            maxLength?: number | undefined;
            maxLengthError?: string | undefined;
            pattern?: string | undefined;
            patternError?: string | undefined;
            enum?: {
                label: string;
                value: string;
            }[] | undefined;
            defaultValue?: string | undefined;
        } | undefined;
        help?: string | undefined;
    } | {
        type: "datetime";
        kind: "date" | "datetime";
        help?: string | undefined;
    } | {
        type: "boolean";
        kind: "checkbox" | "toggle";
        help?: string | undefined;
    } | {
        type: "number";
        kind: "number" | "percentage" | "rating";
        validation?: {
            min?: number | undefined;
            minError?: string | undefined;
            max?: number | undefined;
            maxError?: string | undefined;
            integer?: boolean | undefined;
        } | undefined;
        help?: string | undefined;
    }) & {
        name: string;
        label?: string | undefined;
    })[];
    help?: string | undefined;
}, null>;
export declare const ContentModelSchema: ss.Struct<{
    name: string;
    json: {
        type: "string";
        kind: "string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url";
        validation?: {
            minLength?: number | undefined;
            minLengthError?: string | undefined;
            maxLength?: number | undefined;
            maxLengthError?: string | undefined;
            pattern?: string | undefined;
            patternError?: string | undefined;
            enum?: {
                label: string;
                value: string;
            }[] | undefined;
            defaultValue?: string | undefined;
        } | undefined;
        help?: string | undefined;
    } | {
        type: "datetime";
        kind: "date" | "datetime";
        help?: string | undefined;
    } | {
        type: "boolean";
        kind: "checkbox" | "toggle";
        help?: string | undefined;
    } | {
        type: "number";
        kind: "number" | "percentage" | "rating";
        validation?: {
            min?: number | undefined;
            minError?: string | undefined;
            max?: number | undefined;
            maxError?: string | undefined;
            integer?: boolean | undefined;
        } | undefined;
        help?: string | undefined;
    } | {
        type: "object";
        fields: (({
            type: "string";
            kind: "string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url";
            validation?: {
                minLength?: number | undefined;
                minLengthError?: string | undefined;
                maxLength?: number | undefined;
                maxLengthError?: string | undefined;
                pattern?: string | undefined;
                patternError?: string | undefined;
                enum?: {
                    label: string;
                    value: string;
                }[] | undefined;
                defaultValue?: string | undefined;
            } | undefined;
            help?: string | undefined;
        } | {
            type: "datetime";
            kind: "date" | "datetime";
            help?: string | undefined;
        } | {
            type: "boolean";
            kind: "checkbox" | "toggle";
            help?: string | undefined;
        } | {
            type: "number";
            kind: "number" | "percentage" | "rating";
            validation?: {
                min?: number | undefined;
                minError?: string | undefined;
                max?: number | undefined;
                maxError?: string | undefined;
                integer?: boolean | undefined;
            } | undefined;
            help?: string | undefined;
        }) & {
            name: string;
            label?: string | undefined;
        })[];
        help?: string | undefined;
    };
    label?: string | undefined;
}, {
    label: ss.Struct<string | undefined, null>;
    name: ss.Struct<string, null>;
    json: ss.Struct<{
        type: "string";
        kind: "string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url";
        validation?: {
            minLength?: number | undefined;
            minLengthError?: string | undefined;
            maxLength?: number | undefined;
            maxLengthError?: string | undefined;
            pattern?: string | undefined;
            patternError?: string | undefined;
            enum?: {
                label: string;
                value: string;
            }[] | undefined;
            defaultValue?: string | undefined;
        } | undefined;
        help?: string | undefined;
    } | {
        type: "datetime";
        kind: "date" | "datetime";
        help?: string | undefined;
    } | {
        type: "boolean";
        kind: "checkbox" | "toggle";
        help?: string | undefined;
    } | {
        type: "number";
        kind: "number" | "percentage" | "rating";
        validation?: {
            min?: number | undefined;
            minError?: string | undefined;
            max?: number | undefined;
            maxError?: string | undefined;
            integer?: boolean | undefined;
        } | undefined;
        help?: string | undefined;
    } | {
        type: "object";
        fields: (({
            type: "string";
            kind: "string" | "brand_id" | "category_id" | "color" | "content_block_id" | "dropdown" | "file_id" | "image_file_id" | "product_id" | "radio" | "textarea" | "variant_id" | "web_url";
            validation?: {
                minLength?: number | undefined;
                minLengthError?: string | undefined;
                maxLength?: number | undefined;
                maxLengthError?: string | undefined;
                pattern?: string | undefined;
                patternError?: string | undefined;
                enum?: {
                    label: string;
                    value: string;
                }[] | undefined;
                defaultValue?: string | undefined;
            } | undefined;
            help?: string | undefined;
        } | {
            type: "datetime";
            kind: "date" | "datetime";
            help?: string | undefined;
        } | {
            type: "boolean";
            kind: "checkbox" | "toggle";
            help?: string | undefined;
        } | {
            type: "number";
            kind: "number" | "percentage" | "rating";
            validation?: {
                min?: number | undefined;
                minError?: string | undefined;
                max?: number | undefined;
                maxError?: string | undefined;
                integer?: boolean | undefined;
            } | undefined;
            help?: string | undefined;
        }) & {
            name: string;
            label?: string | undefined;
        })[];
        help?: string | undefined;
    }, null>;
}>;
export declare type ContentModelSchemaType = ss.Infer<typeof ContentModelSchema>;
export declare function parseContentModelSchema(data: string): ContentModelSchemaType;
export declare function generateContentModelTypescriptCode(schemas: ContentModelSchemaType[]): string;
